function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

// @ts-nocheck
import React, { useState, useEffect } from 'react';
import * as FishxIcons from '@fishx/icons';
import { createFromIconfontCN, PCheckOutlined } from '@fishx/icons'; // import "@whalecloud/fdx-theme-fdx/icon-picker.less";

import "./index.less";
var allIcons = FishxIcons;

var IconList = function IconList(_ref) {
  var dataSource = _ref.dataSource,
      iconChange = _ref.iconChange,
      currentIcon = _ref.currentIcon,
      setIconType = _ref.setIconType,
      readonly = _ref.readonly,
      displayFromIconfontCN = _ref.displayFromIconfontCN,
      showColorSelect = _ref.showColorSelect,
      currentColor = _ref.currentColor,
      colorChange = _ref.colorChange;
  var ColorList = ['#E91E63', '#FF9700', '#4EAF50', '#07BCD4', '#2196F3', '#9E27B1', '#4051B5', '#455A63'];

  var _useState = useState(-1),
      _useState2 = _slicedToArray(_useState, 2),
      selectedColor = _useState2[0],
      setSelectedColor = _useState2[1];

  var _useState3 = useState(''),
      _useState4 = _slicedToArray(_useState3, 2),
      backgroundColor = _useState4[0],
      setBackgroundColor = _useState4[1];

  var _useState5 = useState(dataSource),
      _useState6 = _slicedToArray(_useState5, 2),
      renderData = _useState6[0],
      setRenderData = _useState6[1];

  var handleClick = function handleClick(index) {
    setBackgroundColor(ColorList[index]);
    colorChange(ColorList[index]);
    setSelectedColor(index);
    if (iconChange) iconChange({
      name: currentIcon,
      color: ColorList[index]
    });
  };

  var IconFont = createFromIconfontCN({
    scriptUrl: displayFromIconfontCN
  });

  var Component = function Component(_ref2) {
    var type = _ref2.type;

    if (displayFromIconfontCN) {
      return /*#__PURE__*/React.createElement(IconFont, {
        type: type
      });
    } else {
      var FishIcon = allIcons[type];
      return /*#__PURE__*/React.createElement(FishIcon, null);
    }
  };

  useEffect(function () {
    if (displayFromIconfontCN) {
      var xhr = new XMLHttpRequest();
      xhr.open("GET", displayFromIconfontCN);

      xhr.onreadystatechange = function () {
        if (xhr.readyState === 4 && xhr.status === 200) {
          var pattern = /icon-(?:[A-z]|[0-9]|-|_)*/g;
          setRenderData(xhr.response.match(pattern));
        }
      };

      xhr.send();
    }
  }, []);
  useEffect(function () {
    setBackgroundColor(currentColor);
    setSelectedColor(-1);
  }, [currentColor]);
  return /*#__PURE__*/React.createElement("div", {
    className: "listStyle"
  }, showColorSelect ? /*#__PURE__*/React.createElement("div", {
    style: {
      width: '100%'
    }
  }, /*#__PURE__*/React.createElement("ul", {
    className: "colorUl"
  }, ColorList.map(function (v, index) {
    return /*#__PURE__*/React.createElement("div", {
      style: {
        backgroundColor: v
      },
      className: "colorLi",
      onClick: function onClick() {
        handleClick(index);
      },
      key: v
    }, index === selectedColor ? /*#__PURE__*/React.createElement(PCheckOutlined, {
      className: "checkIcon"
    }) : null);
  }))) : null, renderData.map(function (v) {
    return /*#__PURE__*/React.createElement("div", {
      key: v,
      className: v && currentIcon && v === currentIcon ? showColorSelect && backgroundColor ? 'activeColor' : 'active' : '',
      onClick: function onClick() {
        if (readonly) return;
        if (setIconType) setIconType(v);
        if (iconChange) iconChange({
          name: v,
          color: backgroundColor ? backgroundColor : ''
        });
      },
      style: v && currentIcon && v === currentIcon ? {
        backgroundColor: backgroundColor
      } : null
    }, /*#__PURE__*/React.createElement(Component, {
      type: v
    }));
  }));
};

export default IconList;